/// <reference types="react" />
export declare function deepObjectEntries(object: Record<string, any>, conditionFn?: (key: string, value: any) => boolean): [any, string, any, any][];
export declare function excludeProperties<T, K extends keyof T>(object: T, ...keys: K[]): Pick<T, Exclude<keyof T, K>>;
export declare function pickProperties<T, K extends keyof T>(object: T, ...keys: K[]): Pick<T, K>;
export declare function mergeRefs<E extends Element>(...refs: (React.ForwardedRef<any> | null | undefined)[]): ((instance: E | null) => void) | undefined;
export declare function removeDuplicateElements<T>(array: T[]): T[];
export declare function removeUnusedElement<T extends Element>(elements: T[]): T[];
export declare function isSelectElement(element: Element): element is HTMLSelectElement;
export declare function isTextAreaElement(element: Element): element is HTMLTextAreaElement;
export declare function isInputElement(element: Element): element is HTMLInputElement;
export declare function mergeCallbacks(...callbacks: (Function | null | undefined)[]): ((...args: any[]) => void) | undefined;
export declare function unflattenObject(object: Record<string, any>, getValue?: (sourceKey: string) => any): Record<string, any>;
